#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <sys/file.h>
#include <string.h>
#include <malloc.h>
#include "codecdecl.h"
#include "util.h"
#include "alloc.h"
#include "filtering_k.h"

int main(int argc,char *argv[])
{  /* BEGIN MAIN */
	FILE *fInputFile;
	int FileSize;	
	int HeaderInfoSize=38;
	int TotNoOfFrames=32, FrameNo;
	float **ArithDecodedFrames;
	float *DecodedFrame;
	float **FilteredFrames, *MovieFrame, **InvDCTFrames;
	float *DummyFrameCrCb, *FrameFilt;
//	float **FiltPic;

	char ArithCodeFile[80];
	char MovieFile[80];
//	char TmpName[80];
	FILE *fMovie;

	unsigned char *Code; 

	int argcc, CodeCnt=0, buffer;
	int i,j,l;
//	int k;
	int ReturnValue;

	struct DecoderArgs Args;	
	
	CABAC_DecoderEnvironment *CodingEnvironment;	

	//default CODEFILE and output-file
	strcpy(MovieFile,"DecodedMovie.yuv");
	strcpy(ArithCodeFile,"..\\VideoEncoder\\CODEFILE"); 
	
	for (argcc=1;argcc<argc;argcc++){
    	if(argv[argcc][0]!='-'){ 
			fprintf(stderr,"Bad argument!");
			exit(ERROR);
		}
      	else switch (argv[argcc][1]){      					
			case 'i':  /* input sequence */
	        	strcpy(ArithCodeFile,argv[++argcc]);
	        	break;
	      	case 'o':  /* output sequence */
	        	strcpy(MovieFile,argv[++argcc]);
	        	break;									
			default:
				fprintf(stderr,"Unrecognized option!");
				exit(ERROR);
      	}
	}		
	
	//open CODEFILE and file for writing DecodedMovie	
	fMovie = fopen(MovieFile, "wb");
	if ((fMovie = fopen(MovieFile,"wb")) == NULL) {
		printf("Cannot open file %s for writing\n",MovieFile);
		exit(1);
	}
	
	if ((fInputFile = fopen(ArithCodeFile,"rb")) == NULL) {
		printf("Cannot open file %s for reading\n",ArithCodeFile);
		exit(1);
	}	
	
	//printf("Get encoder parameters \n");
	/* Open file for arithmetic code */
	Code=matrix1_uch(HeaderInfoSize);	    
	FileSize = fread(Code,sizeof(unsigned char),HeaderInfoSize,fInputFile);
	if (FileSize != HeaderInfoSize) {
		fprintf(stderr, "Error during reading of header information \n");
		free(Code);
		i=fclose(fInputFile);
		i=fclose(fMovie);
		exit(1);
	}
				
	Read_All_Decoder_Parameters(&Args, Code, &CodeCnt);
	buffer = Args.buffer;
	if ((Args.TotNoOfFrames % buffer) !=0) {
		fprintf(stderr,"TotNoOfFrames not a multiple of buffersize");
		free(Code);
		i=fclose(fInputFile);
		i=fclose(fMovie);
		exit(1);
	}
	
	free(Code);
	Args.codesize = CodeCnt;
	TotNoOfFrames=Args.TotNoOfFrames;
	
	
	//alloc memory for CABAC Environment
	CodingEnvironment = init_decoder_environment(&Code,&CodeCnt);
	
	
	for (FrameNo=0; FrameNo<TotNoOfFrames; FrameNo+=buffer) {		
		//alloc memory
		ArithDecodedFrames = matrix2_f(Args.height*Args.width,buffer);
		FilteredFrames = matrix2_f(Args.height_old*Args.width_old,buffer);
		DecodedFrame = matrix1_f(Args.height_old*Args.width_old);
		
		printf("Decode frames number %i to number %i \n", FrameNo,FrameNo+buffer-1);											
		ReturnValue = ImageDecode(ArithDecodedFrames,&Code, CodeCnt, &Args,fInputFile,CodingEnvironment);
		
		
		for (i=0; i<buffer; i++) {
			l=0;
			for (j=0;j<Args.height_old*Args.width_old;j++) {
				DecodedFrame[l] = ArithDecodedFrames[l][i];
				l++;
			}
			
//			sprintf(TmpName,"DecodedPic%i.txt",i);
//			l=0;
//			for (j=0; j<Args.height; j++) {
//				for (k=0; k<Args.width; k++) {
//					InvDCTFrames[j][k] = DecodedFrame[l++];
//				}
//			}
//			writeTxtFile2_f(TmpName,InvDCTFrames,Args.height, Args.width);
				
			//synthesis-filtering
			//printf("Synthesis filtering frame number %i\n",FrameNo+i);
			FrameFilt = matrix1_f(Args.height_old*Args.width_old);
			synthesis(DecodedFrame, FrameFilt, Args.height_old, Args.width_old, Args.height, Args.width,Args.levels);
			
			l=0;
			for(j=0; j<Args.height_old*Args.width_old; j++){
				FilteredFrames[l][i] = FrameFilt[l];
				l++; 
			}
			free(FrameFilt);
			// skriver ut hvert filtrerte bilde
//			FiltPic = matrix2_f(Args.height_old, Args.width_old);
//			for (i=0; i<buffer; i++) {	
//				l=0;
//				for (j=0;j<Args.height_old;j++){
//					for (k=0; k<Args.width_old; k++) {
//						FiltPic[j][k] = FilteredFrames[l++][i];
//					}
//				}
//				sprintf(TmpName,"SynthesisPic%i.txt",i);
//				writeTxtFile2_f(TmpName, FiltPic, Args.height_old, Args.width_old);
//			}
//			freematrix2_f(FiltPic, Args.height_old, Args.width_old);
				
				
		}
		free(DecodedFrame);		
		freematrix2_f(ArithDecodedFrames,Args.height_old*Args.width_old,buffer);
			
		//invers DCT
		//printf("Invers DCT \n");
		InvDCTFrames = matrix2_f(Args.height_old*Args.width_old, buffer);
		idct(FilteredFrames, InvDCTFrames, Args.height_old, Args.width_old, buffer);
		freematrix2_f(FilteredFrames, Args.height_old*Args.width_old, buffer);
			
		//skriver ut bildene etter idct-operasjonen
//		FiltPic = matrix2_f(Args.height_old, Args.width_old);
//		for (i=0; i<buffer; i++) {	
//			l=0;
//			for (j=0;j<Args.height_old;j++){
//				for (k=0; k<Args.width_old; k++) {
//					//FiltPic[j][k] = InvDCTFrames[l++][i];
//					FiltPic[j][k] = (float)((int)InvDCTFrames[l++][i]);
//					if (FiltPic[j][k]>=255)
//						FiltPic[j][k] = 255;
//					if (FiltPic[j][k] <= 0)
//						FiltPic[j][k] =0;
//				}
//			}
//			sprintf(TmpName,"IDCT%i.txt",i);
//			writeTxtFile2_f(TmpName, FiltPic, Args.height_old, Args.width_old);
//		}
//		freematrix2_f(FiltPic, Args.height_old, Args.width_old);


		//Frame for Cr and Cb component
		DummyFrameCrCb = matrix1_f(Args.height_old/2*Args.width_old/2);
		for (i=0; i<Args.height_old/2*Args.width_old/2; i++) {
			DummyFrameCrCb[i] = 128;
		}
		
		//writing to decoded YUV movie file
		//printf("write to movie-file \n");
			
		MovieFrame=matrix1_f(Args.height_old*Args.width_old);		
		for (i=0; i<buffer; i++) {
			for (j=0; j<Args.height_old*Args.width_old; j++) {
				MovieFrame[j] = InvDCTFrames[j][i];
			}
			Putframe2(Args.height_old*Args.width_old,MovieFrame,fMovie);		
//			sprintf(TmpName,"MovieFrame%i.txt",i);
//			writeTxtFile1_f(TmpName, MovieFrame, Args.height_old*Args.width_old);
				
			//adding the dummyframes for the Cr and Cb component
			Putframe2(Args.height_old/2*Args.width_old/2,DummyFrameCrCb,fMovie);
			Putframe2(Args.height_old/2*Args.width_old/2,DummyFrameCrCb,fMovie);				
		}
		free(MovieFrame);
		free(DummyFrameCrCb);	
		freematrix2_f(InvDCTFrames, Args.height_old*Args.width_old, buffer);			
	}
	
	delete_decoder_environment(CodingEnvironment);
	
	
	//close input and outputfile and return
	i= fclose(fInputFile);
	i=fclose(fMovie);
	return 0;
}
