#include "codecdecl.h"
#include "alloc.h"


void invunifquant(float **SubbandImage,short int **QuantIndexArray,int RowsImage,int ColsImage,int NoOfSubbands,int QuantStepSize,int Threshold)
{  /* BEGIN */   
//   	fprintf(stderr,"CodeCnt =%i \n",*CodeCnt);
	Inv_Quantization(QuantIndexArray,SubbandImage,RowsImage,ColsImage,QuantStepSize,Threshold,NoOfSubbands);				
}


void Inv_Quantization(short int **QuantIndexArray,float **SubbandImage,int RowsImage,int ColsImage,float QuantStepSize,float Threshold,int NoOfSubbands)
{   
   int i, j;
	
   /* Inverse uniform midtread quantization */
   for(i=0;i<RowsImage;i++){
      for(j=0;j<ColsImage;j++){
			/* Inverse quantization */
			if ((i>=RowsImage/NoOfSubbands) || (j>=ColsImage/NoOfSubbands)){
				SubbandImage[i][j]=Inv_Unif_Quant(QuantIndexArray[i][j],QuantStepSize,Threshold);
			}	
		}	
	}
}

float Inv_Unif_Quant(short int QuantIndex,float QuantStepSize,float Threshold)
{
	float QuantRepLevel;	

	/* Find quantizer representation levels */
	if(QuantIndex == 0){
		QuantRepLevel=0.0;
	}
	
	else if(QuantIndex < 0){
		QuantRepLevel=(QuantIndex+0.5)*QuantStepSize-Threshold;
	} 
	else{
		QuantRepLevel=(QuantIndex-0.5)*QuantStepSize+Threshold;
	}
   return(QuantRepLevel);
}
