#include <stdio.h>
#include "codecdecl.h"
#include "util.h"
#include "alloc.h"

#define TRUE 1
#define FALSE 0

void read_macroblock (MacroBlock* mb,CABAC_DecoderEnvironment* Environment,int RowsImage,int ColsImage,int NoOfSubbands) {
	//int index;
	TextureInfoContexts* tex_ctx = Environment->tex_ctx;
	MotionInfoContexts* mot_ctx = Environment->mot_ctx;
	DecodingEnvironment* dep =  &(Environment->partArr)->de_cabac;
	
//	int no_of_mbs = (RowsImage*ColsImage)/(NoOfSubbands*NoOfSubbands);
	int index=0;
	int no_of_mb_pr_col = ColsImage/NoOfSubbands;
	int mb_col_pos, mb_row_pos;
	int end_of_frame=FALSE;
	
	while (!end_of_frame) {
		mb_col_pos = index%no_of_mb_pr_col;
		mb_row_pos = index/no_of_mb_pr_col;
		
		//set mb-data
		mb[index].position_x = mb_col_pos;
		mb[index].position_y = mb_row_pos;
		
		//check if availability of neighbor macroblocks		
		if (index!=0 && mb_col_pos!=0)
			mb[index].mb_available_left = &mb[index-1];
		else
			mb[index].mb_available_left = NULL;
		if (mb_row_pos != 0)
			mb[index].mb_available_up = &mb[index-no_of_mb_pr_col];
		else
			mb[index].mb_available_up = NULL;
		
		
		read_one_macroblock(&mb[index],tex_ctx,mot_ctx,dep);
		
//		if (index<10) {
//			fprintf(stderr,"CodeCnt= %i , Debits_to_go = %i, coeff_cnt= %i and mb nr= %i \n",*dep->Dcodestrm_len,dep->Dbits_to_go,mb[index].coeff_cnt,index);
//		}
		
		
		//check if it is the last MB in this frame/slice
		end_of_frame = exit_macroblocks(dep);
								
		index++;
						
	}			
}


void read_one_macroblock(MacroBlock* mb,TextureInfoContexts* tex_ctx,MotionInfoContexts* mot_ctx,DecodingEnvironment* dep) {	
	readMB_skip_flagInfo_CABAC(dep,mb,mot_ctx);
	
	if (mb->has_none_zero_coeffs==1) { //has significant coeffs
		readLumaCoeff8x8_CABAC(mb,tex_ctx,mot_ctx,dep);		
	}
}

void readLumaCoeff8x8_CABAC(MacroBlock* mb,TextureInfoContexts* tex_ctx,MotionInfoContexts* mot_ctx,DecodingEnvironment* dep) {
	int type = 2; //DEFAULT????
		
	mb->coeff_cnt = read_significance_map(mb,dep,tex_ctx,type,mb->coeffs);

	read_significant_coefficients(mb,dep,tex_ctx,type,mb->coeffs);			
}

//check if this is the last macroblock in the frame
int exit_macroblocks(DecodingEnvironment* dep_dp) {
	int end_of_picture;
	
	end_of_picture = biari_decode_final (dep_dp);
	return end_of_picture;
}
