#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include "constants.h"
#include "filt_par.h"
#include "filt_tree.h"
#include "alloc.h"
#include "filtering_k.h"
#include "util.h"

void synthesis(float *InputImage, float* OutputImage, int nrows, int ncols, int nrowse, int ncolse, int filterlevels) {
	float *sub1,*Ye;
	int screenflag=0;
	fil_tree.levels = filterlevels;
	
	//synthesis filter dyadic split in LPLP
	if (fil_tree.levels > 0){
		sub1=matrix1_f(nrowse*ncolse);
		Syn_fbank_Tree(nrowse,ncolse,InputImage,sub1,fil_tree,screenflag);
		//free(InputImage);
	}
	else{
		sub1=InputImage;
	}
	
	//synthesis filtering of Frame
	Ye = matrix1_f(nrowse*ncolse);
	Syn_fbank_Par(nrowse,ncolse,sub1,Ye,fil_par,screenflag);
	if (fil_tree.levels >0)
		free(sub1);
	
	/* Reduce the image */
	Reduce_Image(nrows,ncols,nrowse,ncolse,Ye,OutputImage,screenflag);
  	free(Ye);
}
