typedef unsigned char boolean;
#define ZERO  0 /* binary 0 */
#define ONE   1 /* binary 1 */
#define ZTR   2 /* binary 00 */
#define POS   3 /* binary 10 */
#define NEG   4 /* binary 11 */
#define IZ    5 /* binary 010*/
#define AZTR  6 /* binary 011*/
#define NC	  0 /* not coded */


typedef struct ezw_element {
	struct ezw_element *up_left,*up_right,*down_left,*down_right;
	struct ezw_element *parent;
	int pos_x,pos_y;	
	unsigned char status;
	int code;
	float value;
} EZWelement;



void ReadFrameFromFile(char[80],float**,int,int);
float max_value_in_matrix(float**,int,int,int);
void init_EZW(float**,EZWelement*,int,int,int,int);
void get_children(EZWelement*,int,int,int,int,int,int,int);
int get_parent(int,int,int,int,int,int,int);
int coeff2scan(int,int,int,int,int,int);
void scan2coeff(int,int*,int*,int,int,int,int);
void EZW_code(EZWelement*,float**,int,int,int,int,int,float,float,unsigned char*,int*);
float max_descendant(EZWelement*,float);
int code(EZWelement*,float,float);
void process_element(EZWelement*,float,float);
void to_sub_list(float);
void output_code(int,unsigned char*,int*);
void put_bit(char,unsigned char*,int*);
void dominant_pass(EZWelement*,int,int,int,int,float,float,unsigned char*,int*);
void subordinate_pass(float,int,float,float,unsigned char*,int*);
void set_state(EZWelement*,unsigned char);
float find_mean_and_subtract(float**,int,int,int,int,float);

//fifo.c
extern char fifo_empty;

//void put_in_fifo(EZWelement *d);
//EZWelement* get_from_fifo(void);
void put_in_fifo(int d);
int get_from_fifo(void);
void destroy_fifo(void);
void initialize_fifo(void);


