#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <sys/file.h>
#include <string.h>
#include <malloc.h>
#include <time.h>
#include "util.h"
#include "filtering_k.h"
#include "alloc.h"
#include "codecdecl.h"
#include "constants.h"
#define TRUE 1
#define FALSE 0
//#include <iostream>
//using namespace std;

int main(int argc,char *argv[]) {  /* BEGIN MAIN */
	int argcc,mode=2,nrows,ncols,oflag=FALSE,i,j,framenr;
//	int k,l,m;
    int iTest,nrows_exp,ncols_exp;// FDArithCode;
   	int TotNoOfFrames=8;
   	int WriteEncoderParams = TRUE;
   	int CodeCnt=0;
   	int EZWSize=0;
   	int CABACSize=0;
   	float QuantStepSize=8.0, Threshold=1.25;
   	float LPQuant=0, LPThreshold=0;
    float **piccoeff,**CrCb_tmp,**dctcoeff,**filterdct;
    float *DummyYUV, *DummyCrCb;
    char ifile[80],ofile[80];
    int nlevels=3,buffer=8;
    unsigned char *Code;
    FILE *fOutputfile; 
    int ReturnValue;
	char ArithCodeFile[80];
	char TmpName[40];
	double CABAC_time=0,TOTAL_time=0;
	struct EncoderArgs Args;
	CABAC_EncoderEnvironment *CodingEnvironment;		//needed for CABAC encoding
	clock_t start_clock,stop_clock;
	
	strcpy(ifile,"news_cif_ori90.yuv");
	
    FILE *fInput,*fOutput;
    for(argcc=1; argcc<argc; argcc++){
	    if(argv[argcc][0] != '-'){
	      fprintf(stderr,"Bad argument!");
	      exit(1);
	    }
	    else{
	      switch (argv[argcc][1]){
	      case 'i':  /* input sequence */
	        strcpy(ifile,argv[++argcc]);
	        break;
	      case 'o':  /* output sequence */
	        strcpy(ofile,argv[++argcc]);
	        oflag=TRUE;
	        break;
	      case 'm': /* type of sequence */
	        mode = atoi(argv[++argcc]);
	        break;
	      case 'b': /*buffersize*/
	        buffer = atoi(argv[++argcc]);
	        break;
	      case 'f': /*TotNoOfFrames*/
	      	TotNoOfFrames = atoi(argv[++argcc]);
	      	break;
	      case 'q': /*QuantStepSize*/
	      	QuantStepSize = (float)atof(argv[++argcc]);
	      	break;
	      case 't': /*Threshold*/
	      	Threshold = (float)atof(argv[++argcc]);
	      	break;
	      case 'l': /*LP-Threshold*/
	      	LPThreshold = (float)atof(argv[++argcc]);
	      	break;
	      case 'n': /*LP-QuantStepsize*/
	      	LPQuant = (float)atof(argv[++argcc]);
	      	break;		     
	      default:
	      	fprintf(stderr, "Wrong input parameter %c \n",argv[argcc][1]);
	      	break;
	      }
	    }
    }
    if ((fInput = fopen(ifile,"rb")) == NULL){
    	fprintf(stderr,"Cannot open file %s for reading\n",ifile);
	    exit(1);
  	}
  	if (oflag){
	    if ((fOutput = fopen(ofile,"wb")) == NULL) {
	      printf("Cannot open file %s for writing\n",ofile);
	      exit(1);
	    }
	}
	//create code-file
	strcpy(ArithCodeFile,"CODEFILE");
	if ((fOutputfile = fopen(ArithCodeFile,"wb")) == NULL){
    	fprintf(stderr,"Cannot open file %s for writing\n",ArithCodeFile);
	    exit(1);
  	}	
	if (LPQuant == 0)
		LPQuant = QuantStepSize;  	
	if (LPThreshold == 0)
		LPThreshold = Threshold;
	Threshold *= QuantStepSize;
	LPThreshold *= LPQuant;

    switch (mode){
	  case 1:  /* qcif */
	    nrows = 144;
	    ncols = 176;
	    break;
	  case 2:  /* cif */
	    nrows = 288;
	    ncols = 352;
	    break;
	  case 3:  /* sif */
	    nrows = 240;
	    ncols = 352;
	    break;
	  case 4:
	    nrows = 512;
	    ncols = 512;
	    break;
	  default:
	    perror("Illegal mode\n");
	    exit(1);
	}
	start_clock = clock();
	//alloc memory for CodingEnvironment
	CodingEnvironment = init_encoder_environment(&Code, &CodeCnt);
	
	fprintf(stderr,"\n\n");
			

	for (framenr=0; framenr<TotNoOfFrames; framenr+=buffer) {
		fprintf(stderr, "Encoding of frame number %i to number %i\n",framenr,framenr+buffer-1);
		
		//if oflag==TRUE
		//write Y-information to new movie-file
		if (oflag) {
			DummyCrCb = matrix1_f(nrows/2*ncols/2);
			DummyYUV = matrix1_f(nrows*ncols);
			for (i=0; i<nrows/2*ncols/2;i++) {
				DummyCrCb[i] = 128;
			}
		}
		piccoeff = matrix2_f(nrows*ncols,buffer);
	  	CrCb_tmp = matrix2_f(nrows/2*ncols/2,1); //behandler ikke Cr og Cb

//***************************************************************

		//BUFFER FRAMES
		//fprintf(stderr, "Read frames from moviefile\n");
		for (i=0;i<buffer;i++) {
			Getframe2(nrows*ncols,i,piccoeff,fInput);	//laster luminansrammen
			Getframe2(nrows/2*ncols/2,0,CrCb_tmp,fInput);	//laster Cb
			Getframe2(nrows/2*ncols/2,0,CrCb_tmp,fInput);	//laster Cr
			if (oflag) {
				for (j=0;j<nrows*ncols;j++) {
					DummyYUV[j] = piccoeff[j][i];
				}
				Putframe2(nrows*ncols,DummyYUV,fOutput);
				Putframe2(nrows/2*ncols/2, DummyCrCb, fOutput);
				Putframe2(nrows/2*ncols/2, DummyCrCb, fOutput);
			} 
		}
		freematrix2_f(CrCb_tmp, nrows/2*ncols/2, 1);
		
		if(oflag) {
			free(DummyYUV);
			free(DummyCrCb);
		}
				
		//write original frames to .txt files
//		dctcoeff = matrix2_f(nrows, ncols);
//		DummyYUV = matrix1_f(nrows*ncols);
//		for(i=0;i<buffer; i++) {
//			l=0;
//			for (j=0; j<nrows; j++) {
//				for (k=0; k<ncols; k++) {
//					DummyYUV[l] = piccoeff[l++][i];
//					//dctcoeff[j][k] = piccoeff[l++][i];
//				}
//			}
//			sprintf(TmpName,"picture%i.txt",i);
//			//writeTxtFile2_f(TmpName, dctcoeff, nrows,ncols);
//			writeTxtFile1_f(TmpName, DummyYUV, nrows*ncols);
//		}
//		freematrix2_f(dctcoeff, nrows, ncols);
//		free(DummyYUV);
		

//***************************************************************		    
	    
	    //DCT Transformation
		//fprintf(stderr,"DCT transformation\n");
		dctcoeff = matrix2_f(nrows*ncols,buffer);	
		dct(piccoeff, dctcoeff, nrows, ncols, buffer);
		freematrix2_f(piccoeff, nrows*ncols, buffer);	
				
		//Write DCT-transformed pictures to .txt files
//		piccoeff = matrix2_f(nrows, ncols);
//		for(i=0;i<buffer; i++) {
//			l=0;
//			for (j=0; j<nrows; j++) {
//				for (k=0; k<ncols; k++) {
//					piccoeff[j][k] = dctcoeff[l++][i];
//				}
//			}
//			sprintf(TmpName,"dctpic%i.txt",i);
//			writeTxtFile2_f(TmpName, piccoeff, nrows,ncols);
//		}
//		freematrix2_f(piccoeff, nrows, ncols);										
					
					

//***************************************************************
					
//		Spatial filtering, using 64-subbands filterbank
		//fprintf(stderr, "Spatial filtering with 64-subband filterbank\n");
		if ((nrows%NOOFSUBBANDSLUMIN)!=0 || (ncols%NOOFSUBBANDSLUMIN)!=0) {		
			expanded_size(nrows, ncols, 1, 1, NPARLEVELS,1, &nrows_exp, &ncols_exp);	
		}
		else {		
			//default
			nrows_exp = nrows;
			ncols_exp = ncols;
		}
		
		filterdct = matrix2_f(nrows_exp*ncols_exp, buffer);
		Args.levels = (unsigned char)analysis(filterdct, nrows,ncols,dctcoeff,nlevels,buffer,nrows_exp,ncols_exp);	
		freematrix2_f(dctcoeff, nrows*ncols, buffer);
					
//		DummyCrCb = matrix1_f(967680);
//		m=0;
		//writing spatial filtered dct-frames to .txt files
//		dctcoeff = matrix2_f(nrows_exp, ncols_exp);
//		for(i=0;i<buffer; i++) {
//			l=0;
//			for (j=0; j<nrows_exp; j++) {
//				for (k=0; k<ncols_exp; k++) {
//					dctcoeff[j][k] = filterdct[l][i];
////					if (j>=40 || k>48)
////						DummyCrCb[m++] = filterdct[l][i];
//					l++;
//				}
//			}
//			sprintf(TmpName,"Analysis%i.txt",i);
//			writeTxtFile2_f(TmpName, dctcoeff, nrows_exp,ncols_exp);
//		}
//		freematrix2_f(dctcoeff, nrows, ncols);
//		writeTxtFile1_f("All_values_8_frames_no_LPLP.txt",DummyCrCb,967680);
//		free(DummyCrCb);		


//***************************************************************

//		add encoder parameters to a struct for storage
		Args.height=nrows_exp;
		Args.width=ncols_exp;
		Args.height_old=nrows;
		Args.width_old=ncols;	
		Args.quality = QuantStepSize;
		Args.threshold=Threshold;		
		Args.codesize = 0;		//startverdi		
		Args.TotNoOFFrames = TotNoOfFrames;
		Args.buffer = buffer;
		Args.LPquant = LPQuant;
		Args.LPthreshold = LPThreshold;		
		

//***************************************************************

		//ImageEncode
		//Quantization, EZW-coding of LP-LP, CABAC
		ReturnValue=ImageEncode(filterdct,&Code,&Args, fOutputfile, WriteEncoderParams, CodeCnt, CodingEnvironment,&EZWSize,&CABAC_time);
		WriteEncoderParams = FALSE;
//		fprintf(stderr,"Value returned: %d\n",ReturnValue);
	
//		CodeSize=Args.codesize;
//		fprintf(stderr,"Size coded sequence: %d\n",CodeSize);						
				
		freematrix2_f(filterdct, nrows_exp*ncols_exp, buffer);	    
	}
    //close input and output file
    if (oflag) {
		i= fclose(fOutput);
	}
	delete_encoder_environment(CodingEnvironment);
	
	stop_clock = clock();
	TOTAL_time = (double)(stop_clock-start_clock);
	TOTAL_time = (TOTAL_time/(double)CLOCKS_PER_SEC)/(double)TotNoOfFrames;
	
	CodeCnt = ftell(fOutputfile);
	CABACSize = CodeCnt - EZWSize;
	CABAC_time = (CABAC_time/(double)CLOCKS_PER_SEC)/(double)TotNoOfFrames;
	fprintf(stderr, "Total size of encoded movie:%i \n",CodeCnt);
	fprintf(stderr, "Bit pr. pixel= %1.3f \n",(float)CodeCnt*8.0/(float)(nrows*ncols*TotNoOfFrames));
	fprintf(stderr, "BPP = %1.3f, bpp_EZW=%1.3f, bpp_CABAC=%1.3f, time CABAC=%.5f, time TOTAL=%.5f\n",(float)CodeCnt*8.0/(float)(nrows*ncols*TotNoOfFrames),(float)EZWSize*8.0/(float)(nrows*ncols*TotNoOfFrames),(float)CABACSize*8.0/(float)(nrows*ncols*TotNoOfFrames),CABAC_time,TOTAL_time);
	printf("%1.3f %1.3f %1.3f %.5f %5f\n",(float)CodeCnt*8.0/(float)(nrows*ncols*TotNoOfFrames),(float)EZWSize*8.0/(float)(nrows*ncols*TotNoOfFrames),(float)CABACSize*8.0/(float)(nrows*ncols*TotNoOfFrames),CABAC_time,TOTAL_time);
	
	i= fclose(fOutputfile);	
	iTest = fclose(fInput);
    return 0;        
}
