/* \file 
 * \brief Constants used for the subband filtering.
 * \author Probably Arild Fuldseth
 * $Id: constants.h,v 1.2 2005/06/07 14:26:13 hakonsen Exp $
 */
#ifndef _CONSTANTS_H
#define _CONSTANTS_H

#define NTAPS 32               /* filter length */
#define NCH 8                  /* number of channels */
#define NOOFCHANNELS 2         /* Number of channels */
#define NLEVELS 3              /* maximum number of levels */
#define NPARLEVELS 3           /* number of levels in parallel filtering */
#define TRUE 1                 /* logical true */
#define FALSE 0                /* logical false */
#define MAXDIM 65535           /* maximum image dimension */
#define MAXSIZE 16777216       /* maximum image size (4096^2) */
#define PERMS   0666           /* read and write for user group and other */
#define FILE_NAME_LEN 256      /* size of strings for file names */
#define MAXNTAP 9              /* maximum number of taps */
#define MAXNCH 8               /* maximum number of channels */
#define MAXNLEVELS 8           /* maximum number of levels */

#endif
