#ifndef _FILTERING_K_H
#define _FILTERING_K_H

#include "constants.h"

/* Definitions for parallel FB */

struct firspec_par{
  int no_of_taps;
  int channels;
  float a[NCH][NTAPS];
  float b[NCH][NTAPS]; 
};

void synthesis(float*,float*,int,int,int,int,int);
int analysis(float**,int,int,float**,int,int,int,int);
extern void  Anl_fbank_Par(int,int,float*,float*,struct firspec_par,int);
extern void  Syn_fbank_Par(int,int,float*,float*,struct firspec_par,int);
extern void  mirror_anl(int,int,int,float*,float*);
extern void  mirror_syn(int,int,int,float*,float*);

/* Definitions for tree-structured FB */

/* structure for specification of FIR filters */
/* FIR specification for two-channel even/odd length filterbank*/

struct firspec_tree{       
        int levels;
        int nlptaps[NLEVELS];
        int nhptaps[NLEVELS];
        float ana[NLEVELS][NOOFCHANNELS][MAXNTAP];
        float syn[NLEVELS][NOOFCHANNELS][MAXNTAP];
};


extern void  Anl_fbank_Tree(int,int,float*,float*,struct firspec_tree,int);
extern void  Syn_fbank_Tree(int,int,float*,float*,struct firspec_tree,int);


/* low level program specific functions */

extern void  fir_n_filt_m_ana(int,int,float*,float*,struct firspec_tree); 
extern void  fir_n_filt_m_syn(int,int,float*,float*,struct firspec_tree); 

#endif
