#include <stdio.h>
#include "codecdecl.h"
#include "util.h"
#include "alloc.h"

//void write_macroblock (MacroBlock* mb,TextureInfoContexts* tex_ctx,MotionInfoContexts* mot_ctx,EncodingEnvironment* eep,int RowsImage,int ColsImage,int NoOfSubbands) {
void write_macroblock (MacroBlock* mb,CABAC_EncoderEnvironment* Environment,int RowsImage,int ColsImage,int NoOfSubbands,int last_significant_mb) {
	//int index;
	TextureInfoContexts* tex_ctx = Environment->tex_ctx;
	MotionInfoContexts* mot_ctx = Environment->mot_ctx;
	EncodingEnvironment* eep = eep = &(Environment->partArr)->ee_cabac;
	
	int no_of_mbs = (RowsImage*ColsImage)/(NoOfSubbands*NoOfSubbands);
	int i;
	
	for (i=0; i<no_of_mbs; i++) {				
		
		
		//write terminating bit for MB that is not the first one
		if (i!=0) {			
			write_terminating_bit(0,Environment);
		}
			
//		if (i%100==0) {
//			fprintf(stderr,"CodeCnt= %i and mb nr= %i \n",*eep->Ecodestrm_len,i);
//		}
		write_one_macroblock(&mb[i],tex_ctx,mot_ctx,eep);
		
		if (i == last_significant_mb)
			return;				
	}			
}


void write_one_macroblock(MacroBlock* mb,TextureInfoContexts* tex_ctx,MotionInfoContexts* mot_ctx,EncodingEnvironment* eep) {	
	writeMB_skip_flagInfo_CABAC(eep,mb,mot_ctx);
	
	if (mb->has_none_zero_coeffs==1) { //has significant coeffs
		writeLumaCoeff8x8_CABAC(mb,tex_ctx,mot_ctx,eep);		
	}
}

void writeLumaCoeff8x8_CABAC(MacroBlock* mb,TextureInfoContexts* tex_ctx,MotionInfoContexts* mot_ctx,EncodingEnvironment* eep) {
//	int coeffs[64];
//	int i;
	int type = 2; //DEFAULT????
		
	write_significance_map(mb,eep,tex_ctx,type,mb->coeffs,mb->coeff_cnt);

	write_significant_coefficients(mb,eep,tex_ctx,type,mb->coeffs);
//	write_significanse_map
//	write_significant_coeffs
	//send coeffs, coeff_cnt til writeSignificanseMap
	//deretter: writeSignificanseCoeffs
			
}

void write_terminating_bit (short bit,CABAC_EncoderEnvironment* env)
{
  Encoder_DataPartition*          dataPart;
  //const int*              partMap   = assignSE2partition[input->partition_mode];
  EncodingEnvironment*  eep_dp;

  //--- write non-slice termination symbol if the macroblock is not the first one in its slice ---
  dataPart = env->partArr;
  //dataPart = &(img->currentSlice->partArr[partMap[SE_MBTYPE]]); //==img->currentSlice->partArr[0]
  dataPart->bitstream->write_flag = 1;
  eep_dp                          = &(dataPart->ee_cabac);

  biari_encode_symbol_final(eep_dp, bit);
//#if TRACE
//  fprintf (p_trace, "      CABAC terminating bit = %d\n",bit);
//#endif

}
